//
//  ChocoLayerPDF.h
//  ChocoFlopX
//
//  Created by Santiago Lema on 14.04.07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "ChocoLayer.h"

@interface ChocoLayerPDF : ChocoLayer 
{
	CIImageAccumulator* accu;
	
	CIImage* lastValidImage;
	PDFDocument* pdfDoc;
	NSSize pdfSize;
	NSImage* pdfImage;
	NSPDFImageRep* pdfImageRep; 
	NSLock* modifyPDFImageLock;
	
	NSString* sourcePath;
}

-(CIImageAccumulator*) getAccu;
-(CIImage*) getPDFAsImage;
-(BOOL) loadFromPath:(NSString*)path replaceSourcePath:(BOOL)replacePath;
-(void) updatePDFRenderedAndReCreateImage:(BOOL)shouldCreate;
-(void) pdfNeedsRender;

-(void) clonePDFLayer:(ChocoLayerPDF*)cloneme;
-(PDFDocument*) getPDFDocument;
-(NSString*) getSourcePath;
-(void) setSourcePath:(NSString*)str;


- (IBAction) pickNewFile:(id)sender;
- (void)layerPickOpenPanelDidEnd:(NSOpenPanel *)panel returnCode:(int)returnCode contextInfo:(void *)contextInfo;
- (IBAction) updateFileFromOriginal:(id)sender;

@end
